AIX Open Source

  • 1.  Yum shell not working. Trying to reinstall gcc packages.

    Posted Mon August 23, 2021 08:45 PM
    Hello all,

    I'm having compilation errors when installing R language packages on AIX.
    However, that is not my main issue. I have problems running yum shell. See below. 
    I'm not sure if it's yum, python, gcc, openssl, or any other issue.
    Any assistance will be greatly appreciated. 

    Error when running shell to downgrade gcc:
    *Note(same exact error when installing yum.sh)

    >cat /tmp/down.list
    downgrade gcc libgcc libstdc++ libstdc++-devel gcc-c++ gcc-cpp gcc-gfortran libgfortran libgomp
    erase libgcc8
    run

    >yum shell -y /tmp/down.list

    ERROR:root:code for hash md5 was not found.
    Traceback (most recent call last):
      File "/opt/freeware/lib/python2.7/hashlib.py", line 147, in <module>
        globals()[__func_name] = __get_hash(__func_name)
      File "/opt/freeware/lib/python2.7/hashlib.py", line 97, in __get_builtin_constructor
        raise ValueError('unsupported hash type ' + name)
    ValueError: unsupported hash type md5
    ERROR:root:code for hash sha1 was not found.
    Traceback (most recent call last):
      File "/opt/freeware/lib/python2.7/hashlib.py", line 147, in <module>
        globals()[__func_name] = __get_hash(__func_name)
      File "/opt/freeware/lib/python2.7/hashlib.py", line 97, in __get_builtin_constructor
        raise ValueError('unsupported hash type ' + name)
    ValueError: unsupported hash type sha1
    ERROR:root:code for hash sha224 was not found.
    Traceback (most recent call last):
      File "/opt/freeware/lib/python2.7/hashlib.py", line 147, in <module
    Could not load module /opt/freeware/lib/python2.7/site-packages/pycurl.so.
    Dependent module /opt/freeware/lib/libcrypto.a(libcrypto.so) could not be loaded.
    Member libcrypto.so is not found in archive
    Could not load module /opt/freeware/lib/python2.7/site-packages/pycurl.so.
    Dependent module /opt/freeware/lib/python2.7/site-packages/pycurl.so could not be loaded.


    Compilation error installing packages on R language:

    >export STRINGI_DISABLE_CXX11=yes
    >export with_extra_ldflags="-Wl,-bbigtoc"
    >/opt/freeware/bin/R CMD INSTALL Rcpp_0.12.19.tar.gz

    * installing to library '/usr/opt/freeware/lib64/R/library'
    * installing *source* package 'Rcpp' ...
    ** package 'Rcpp' successfully unpacked and MD5 sums checked
    ** using staged installation
    ** libs
            g++ -maix64 -std=gnu++11 -I"/opt/freeware/lib64/R/include" -DNDEBUG -I../inst/include/  -O2 -I/opt/freeware/include -I/usr/include -D_GETDELIM    -O2 -I/opt/freeware/include -I/usr/include -D_GETDELIM  -c Date.cpp -o Date.o
    In file included from /usr/include/sys/resource.h:57,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/sys/wait.h:56,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/stdlib.h:391,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include/c++/stdlib.h:30,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/math.h:1407,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include/c++/cmath:45,
                     from ../inst/include/Rcpp/platform/compiler.h:100,
                     from ../inst/include/Rcpp/r/headers.h:59,
                     from ../inst/include/RcppCommon.h:29,
                     from ../inst/include/Rcpp.h:27,
                     from Date.cpp:31:
    /usr/include/sys/time.h:108:16: error: redefinition of 'struct sigset_t'
    typedef struct sigset_t {
                    ^~~~~~~~
    In file included from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/sys/wait.h:45,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/stdlib.h:391,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include/c++/stdlib.h:30,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/math.h:1407,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include/c++/cmath:45,
                     from ../inst/include/Rcpp/platform/compiler.h:100,
                     from ../inst/include/Rcpp/r/headers.h:59,
                     from ../inst/include/RcppCommon.h:29,
                     from ../inst/include/Rcpp.h:27,
                     from Date.cpp:31:
    /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/sys/types.h:345:16: note: previous definition of 'struct sigset_t'
    typedef struct sigset_t {
                    ^~~~~~~~
    In file included from /usr/include/sys/resource.h:57,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/sys/wait.h:56,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/stdlib.h:391,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include/c++/stdlib.h:30,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/math.h:1407,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include/c++/cmath:45,
                     from ../inst/include/Rcpp/platform/compiler.h:100,
                     from ../inst/include/Rcpp/r/headers.h:59,
                     from ../inst/include/RcppCommon.h:29,
                     from ../inst/include/Rcpp.h:27,
                     from Date.cpp:31:
    /usr/include/sys/time.h:124:3: error: conflicting declaration 'typedef int sigset_t'
    } sigset_t;
       ^~~~~~~~
    In file included from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/sys/wait.h:45,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/stdlib.h:391,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include/c++/stdlib.h:30,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/math.h:1407,
                     from /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include/c++/cmath:45,
                     from ../inst/include/Rcpp/platform/compiler.h:100,
                     from ../inst/include/Rcpp/r/headers.h:59,
                     from ../inst/include/RcppCommon.h:29,
                     from ../inst/include/Rcpp.h:27,
                     from Date.cpp:31:
    /usr/opt/freeware/lib/gcc/powerpc-ibm-aix7.2.0.0/8/include-fixed/sys/types.h:361:3: note: previous declaration as 'typedef struct sigset_t sigset_t'
    } sigset_t;
       ^~~~~~~~
    make: 1254-004 The error code from the last command is 1.
     
     
    Stop.
    ERROR: compilation failed for package 'Rcpp'
    * removing '/usr/opt/freeware/lib64/R/library/Rcpp'
    * installing to library '/usr/opt/freeware/lib64/R/library'

    What we tried:
    • We tried different versions of python. 2.7.10.1, 2.7.13.1, 2.7.18.1
    • Tried to downgrade gcc but can't because of yum problem.


    RPMs:
    >rpm -qa    
    lsof-4.61-4.ppc
    openssl-1.0.2d-1.ppc
    df1000e21410f103-00011000040041500010-1.noarch
    yum-metadata-parser-1.1.4-2.ppc
    libgcc-8-1.ppc
    libstdc++8-8.3.0-4.ppc
    ncurses-6.2-2.ppc
    libffi-3.2.1-3.ppc
    libmpc-1.1.0-1.ppc
    freetype2-2.8-1.ppc
    fontconfig-2.11.95-4.ppc
    libgomp8-8.3.0-4.ppc
    cyrus-sasl-2.1.26-3.ppc
    libssh2-1.9.0-1.ppc
    xz-libs-5.2.5-1.ppc
    libxml2-2.9.10-1.ppc
    libunistring-0.9.10-1.ppc
    libiconv-1.16-1.ppc
    info-6.6-2.ppc
    sqlite-3.32.3-1.ppc
    p11-kit-tools-0.23.16-1.ppc
    gcc8-8.3.0-4.ppc
    gcc-cpp-8-1.ppc
    curl-7.74.0-1.ppc
    libXft-2.3.2-4waixX11.ppc
    gcc-8-1.ppc
    sudo-1.9.5p2-1.ppc
    libpng-1.6.27-3.ppc
    libgfortran8-8.3.0-4.ppc
    libgfortran-8-1.ppc
    cairo-1.14.6-2waixX11.ppc
    pango-1.40.1-2waixX11.ppc
    gcc8-gfortran-8.3.0-4.ppc
    libstdc++8-devel-8.3.0-4.ppc
    gcc-c++-8-1.ppc
    R-3.6.3-1.ppc
    krb5-libs-1.18.3-1.ppc
    yum-3.4.3-8.noarch
    python-2.7.18-1.ppc
    pysqlite-2.8.3-2.ppc
    pci.1014034a.51-15511800-1.noarch
    libgcc8-8.3.0-4.ppc
    zlib-1.2.11-2.ppc
    libstdc++-8-1.ppc
    gmp-6.1.2-1.ppc
    mpfr-4.0.2-2.ppc
    bzip2-1.0.8-2.ppc
    expat-2.2.9-2.ppc
    libgomp-8-1.ppc
    openldap-2.4.56-1.ppc
    tcl-8.6.8-3.ppc
    libtextstyle-0.20.2-1.ppc
    glib2-2.56.1-2.ppc
    bash-5.0.18-1.ppc
    gettext-0.20.2-1.ppc
    readline-8.0-2.ppc
    p11-kit-0.23.16-1.ppc
    sed-4.8-1.ppc
    gcc8-cpp-8.3.0-4.ppc
    gdbm-1.18.1-1.ppc
    libnghttp2-1.41.0-1.ppc
    libXrender-0.9.8-2waixX11.ppc
    tk-8.6.8-3.ppc
    gzip-1.10-1.ppc
    pixman-0.34.0-1.ppc
    libjpeg-9d-1.ppc
    lzo-2.10-2.ppc
    harfbuzz-1.2.7-2.ppc
    pcre-8.44-1.ppc
    gcc-gfortran-8-1.ppc
    ca-certificates-2020.06.01-1.ppc
    gcc8-c++-8.3.0-4.ppc
    AIX-rpm-7.2.5.0-11.ppc
    R-devel-3.6.3-1.ppc
    db-5.3.28-1.ppc
    db-devel-5.3.28-1.ppc
    python-iniparse-0.4-1.noarch
    python-urlgrabber-3.10.1-1.noarch
    python-pycurl-7.43.0-1.ppc
    python-devel-2.7.18-1.ppc

     >lslpp -l | grep -i openssl

    openssl.base 1.0.2.2100 COMMITTED Open Secure Socket Layer
    openssl.license 1.0.2.2100 COMMITTED Open Secure Socket License
    openssl.man.en_US 1.0.2.2100 COMMITTED Open Secure Socket Layer
    openssl.base 1.0.2.2100 COMMITTED Open Secure Socket Layer

    Also customer is running the latest AIX 7.2.

    Thank you.

    ------------------------------
    VINCE DAVIS
    ------------------------------


  • 2.  RE: Yum shell not working. Trying to reinstall gcc packages.

    Posted Tue August 24, 2021 04:28 AM
    The presence of openssl rpm is creating problems. Please remove openssl rpm and then try to upgrade gcc using yum

    ------------------------------
    Ayappan P
    ------------------------------



  • 3.  RE: Yum shell not working. Trying to reinstall gcc packages.

    Posted Tue August 24, 2021 11:28 AM
    Thank you for your response.

    If I remove the openssl rpm, would it disturb ssh or openssl on the OS. Customer is worried that it would disturb their environment. Thank you.

    ------------------------------
    VINCE DAVIS
    ------------------------------



  • 4.  RE: Yum shell not working. Trying to reinstall gcc packages.

    Posted Wed August 25, 2021 03:19 AM
    It won't affect the openssl installp fileset.
    If there is a concern about other applications which depends on openssl rpm, then I would suggested to extract libssl.so & libcrypto.so from /usr/lib/libssl.a (& libcrypto.a) and put it inside the archive of /opt/freeware/lib/libssl.a ( & libcrypto.a) respectively.

    ------------------------------
    Ayappan P
    ------------------------------